#!/bin/bash
VER="1.4.2"
########################################################################################
# Tur-AutoNuke by Turranius ( http://www.grandis.nu/glftpd/ ) turranius@hotmail.com    #
#-[ Introduction ]---------------------------------------------------------------------#
#                                                                                      #
# This is an autonuke script for empty folders, incompleted uploads and banned words.  #
# Read the README for a full list of options.                                          #
#                                                                                      #
#-[ Installation ]---------------------------------------------------------------------#
#                                                                                      #
# Copy this script to /glftpd/bin/ or where ever really. Make it executable.           #
# Read the README!                                                                     #
# Setup all the options below. Be careful unless you want the whole site nuked.        #
# !! Before running it the first time, use the variable test (tur-autonuke.sh test) !! #
#                                                                                      #
#-[ Changelog ]------------------------------------------------------------------------#
#                                                                                      #
# 1.4.2 : Add: You now have the option to have different nuke multipliers per banned   #
#              word. Simply add a *4 where 4 is the multiplier you wish to use for     #
#              word. If no * is specified, it goes for the default multiplier          #
#              specified for the banned word module.                                   #
#              Ex: /site/0DAYS/$today~.German*1:.French*1:.Solaris:.UNIX*4             #
#              .German and .French are nuked x1.                                       #
#              .Solaris is nuked by the default multiplies set in BANMULTIPLIER.       #
#              .UNIX is nuked x4.                                                      #
#              This makes it totally backwards compatible.                             #
#              Once again, loadet speaks out. Thanks.                                  #                         
# 1.4.1 : Fix: As loadet pointed out, if you put .SUBBED as a banned word, it would    #
#              find UNSUBBED and nuke. The dot didnt do very much.                     #
# 1.4   : Add: Added DELETENUKES and TIMETODELEM. It will look for nuked folders in    #
#              the DIRS and delete those that are TIMETODELEM hours old.               #
#              Full test support of course. It will just act as another module.        #
#         Add: Changed CLEANMINUTES to CLEANHOURS so you dont have to think so much.   #
#              It can still be "" to turn this function off.                           #
# 1.4b7 : Fix: If the exact same folder was created multiple times (make/delete/make)  #
#              the MATCHUSER function crapped out. Now, it will ONLY show the name of  #
#              the user who created the folder last instead.                           #
#         Add: Added the ability to have more then one SYMLINKNAME. Just add them all  #
#              with a space inbetween. SYMLINKNAME renamed to SYMLINKNAMES.            #
#              Some zipscripts create different types of symlinks based on whats       #
#              missing from the release. Most people just use one.                     #
#         Add: USEREXCLUDE added. It is only used for the EMBARRES settings in each    #
#              module. You can exclude one user from the loosers output if you do not  #
#              want that user shown. Default is UNKNOWN (as with dark0n3s zipscript).  #
# 1.4b6 : Add: Added HOUR settings to each module. This does NOT change how you should #
#              input any settings. They should still be in minutes. It only changes    #
#              how the bot and log files will be written. See README for full info.    #
#         Add: Added support for 1 week of dated folders. Yes, I could include total   #
#              support for dated dirs instead, but that would be horribly slow.        #
#              Thanks eur0dance for help with date strings :)                          #
#         Add: If it cant find any of the DIRS or BANDIRS specified, it will no longer #
#              halt the script. It will log it to the logfile (or print to screen      #
#              during test), and simply skip that folder.                              #
#         Add: Added NOUSERFOUND for the MATCHUSER setting. If you create a folder     #
#              from shell, it will by default say, "created by someone unknown". Now   #
#              you can change this to something else if you like ("some God" perhaps?).#
#         Add: It will now show prenuke time and nuke time of each module when running #
#              it in test mode.                                                        #
#         Fix: Rewrote how it says minute or minutes (or hour/hours). Not really a fix #
#              since it worked before too, but its cleaner now.                        #
#         Fix: During test mode, it would send prenuke warning, then try again but it  #
#              had already done it. Just happened during test.                         #
# 1.4b5 : Fix: MATCHUSER. Seems checking whos owning the folder and matching the uid   #
#              to a user in the passwd file didnt work too well. It now reads          #
#              glftpd.log and checks who created the folder instead.                   #
#              It might find the wrong name if the same folder has been created by     #
#              another user at another time, but that should only happen while testing.#
#              Removed PASSWD and TRANSLATE as those are not needed anymore.           #
#              If you create the folders from shell, it will say "created by someone   #
#              unknown", because it will not be in the glftpd.log file then.           #
#              It will also say that if you do not log NEWDIR to glftpd.log            #
# 1.4b4 : Fix: Wasnt logging date on pre-nuke warnings. Minor detail.                  #
#         Fix: Wrong folder to empty half-empty nukes in logfile. Minor detail.        #
#         Fix: If a folder is empty and contains a banned word, it will not be warned  #
#              for twice.                                                              #
#         Fix: Finally got rid of the "File not found" error when it hit a symlink,    #
#              with some brainwork from Cruxis -"Live long and prosper"                #
#         Fix: If you had the same uids as gids, MATCHUSER crapped out.                #
#              Kudos goes to Peza for helping me test it in the middle of the night.   #
# 1.4b3 : Fix: Wouldnt send pre nuke warnings on incompletes for a lame reason.        #
# 1.4b2 : Fix: Found a fundemental flaw in the half-empty module combined with dated   #
#              dirs. In short, it indexed the name only, so if Nisses.Roadtrip-SUG in  #
#              0722 was ok, it didnt check it again in 0723 since it was ok in the     #
#              index file. Now indexes the full path to the index file, so remove      #
#              tur-autnuke.index if you are upgrading and let it build a new one.      #
#         Add: Added CLEANMINUTES to the half-empty module.                            #
#              This will ensure that your index file does not grow too big by removing #
#              it after a number of minutes. Default 1440 minutes (every 24 hours).    #
#              It will start the count the first time you run this version.            #
#              Disable by setting it to ""                                             #
#         Fix: MATCHUSER did not work for the incomplete module.                       #
# 1.4b1 : Fix: Minor debug text printed when it found a banned word. No biggie.        #
#         Fix: It displayed the nuke results on shell. Grabbing it now instead and     #
#              parsing it. Leading to:                                                 #
#         Add: Added an EMBARRESS to each module. This will send parsed result from    #
#              the nuke to your GLLOG so the bot can pick it up and announce it.       #
#              It shows how much they lost, which isnt shown in the normal nuke output.#
#         Add: Will now show parent folder of the nuke too when sending nuke warning.  #
#              ( XXX/release instead of just release )                                 #
#         Add: Added option MATCHUSER. With this on TRUE, it will try and display who  #
#              created the dir when it sends a pre-nuke warning.                       #
#              Also added PASSWD and TRANSLATE for this function to work.              #
#         Fix: It had problems nuking for some people cause it used {$folder} when     #
#              nuking (which should be correct). Now it just uses $folder.             #
#              Wont work on folders with spaces or ()[] anymore, but who has those?    #
#         Fix: CLEANMESSAGE will do a check when deleteting dead symlinks too. Not     #
#              just when nuking incomplete releases.                                   #
#         Fix: It now understands singular and plural, and it can make coffee for you. #
#              Seriously thought, it will say minute instead of minutes if the minute  #
#              for prewarning is just 1, when it sends pre-nuke warning to log.        #
# 1.3.2 : Fix: If GLROOT was not /glftpd the nuke wouldnt work 100% of the time.       #
#         Fix: If you had [, ( or { in your nuked_syntax, it would exclude every       #
#              folder it found, hence, not nuking anything.                            #
#         Fix: Could possibly send a prenuke warning on an empty folder in both the    #
#              Totally empty module and from the half-empty module.                    #
#              Never saw it happen, but looked like it could. Fixed though.            #
# 1.3.1 : Fix: If, in glftpd.conf, you have spaces instead of tabs in your             #
#              nukedir_style, you got a lot of errors and it didnt exclude nukes.      #
#              Thats what I get for "borrowing" code from other scripters.             #
#              The old one is still there, remarked out, if for some reason the new    #
#              one dosnt work for you.                                                 #
#         Add: Added nfofix as an excluded folder by default as well. Only had nfo.fix #
#         Fix: You can now use - at the start of a banned word, so when banning a      #
#              group, it will not take the text from anywhere in the foldername.       #
#              This makes it a bit safer. See example and README.                      #
# 1.3   : Add: Made a seperate README file for settings as it got too big.             #
#         Add: Added module "Half-Empty"                                               #
#         Add: Added module "Banned words".                                            #
#              If you are upgrading, make sure to read the README                      #
# 1.2   : Add: Pre-nuke warning added for empty folders too.                           #
#              Both empty dir pre-warnings and incomplete pre-warnings can now be      #
#              disabled separetly, instead of setting GLLOG=""                         #
# 1.1   : Add: It can now send a pre-nuke warning.                                     #
# 1.0   :      Initial release. Works fine.                                            #
#                                                                                      #
#-[ irc ]------------------------------------------------------------------------------#
#                                                                                      #
# Contact Turranius on Efnet. ( turranius / turran / turr|away / turr|work )           #
#                                                                                      #
#-[ Settings ]-------------------------------------------------------------------------#

#--[ Generics: dated dirs - See README for explanation ]--#
today="$( date +%m%d )"                         #Today
yesterday="$( date --date "yesterday" +%m%d )"  #Yesterday
daysago2="$( date --date "-2 day" +%m%d )"      #2 days ago
daysago3="$( date --date "-3 day" +%m%d )"      #3 days ago
daysago4="$( date --date "-4 day" +%m%d )"      #4 days ago
daysago5="$( date --date "-5 day" +%m%d )"      #5 days ago
daysago6="$( date --date "-6 day" +%m%d )"      #6 days ago
daysago7="$( date --date "-7 day" +%m%d )"      #1 week ago
#---------------------------------------------------------#

#--[ Generics: Main settings ]--#
GLROOT="/glftpd"
GLCONF="/etc/glftpd.conf"
GLLOG="/glftpd/ftp-data/logs/glftpd.log"  
LOG="/glftpd/ftp-data/logs/tur-autonuke.log"
TEMPDIR="/glftpd/tmp"

NUKEPROG="/glftpd/bin/nuker"
NUKEUSER="turranius"

DIRS="
/site/VCD
/site/XXX
/site/SVCD
/site/ISO-UTILS
/site/DIVX
/site/0DAYS/$today
/site/0DAYS/$yesterday
/site/0DAYS/$daysago2
"

EXCLUDES="nfofix nfo.fix dirfix dir.fix GROUPS"


#---[ Totally empty module ]---#
TOTALLYEMPTY="TRUE"      # Check for empty folders at all?
PRENUKEEMPTY="TRUE"      # Send pre-nuke warning?
EARLYEMPTY="1"           # Minutes before sending a per-nuke warning.
TIMEEMPTY="11"           # Minutes before nuke.
EMPTYMULTIPLIER="3"      # Nuke multiplier
EMBARRESEMPTY="TRUE"     # Send detailed nuke report.
EMPTYHOURS="FALSE"        # Use hours in bot and log output?


#---[ Half empty module ]---#
HALFEMPTY="TRUE"         # Check for "halfempty" folders at all?
PRENUKEHALFEMPTY="TRUE"  # Send pre-nuke warning?
EARLYHALFEMPTY="3"       # Minumum age to send pre-nuke warning.
TIMEHALFEMPTY="25"       # Minumum age to nuke.
HALFEMPTYMULTIPLIER="3"  # Nuke multiplier
EMBARRESHALF="TRUE"      # Send detailed nuke report.
EMPTYEXCLUDE=".zip .rar .r00 .r01 .mp3 .000 .001" # See README
CLEANHOURS="24"          # Hours between cleaning index file.
HALFHOURS="FALSE"        # Use hours in bot and log output?


#---[ Incomplete module ]---#
INCOMPLETE="TRUE"     # Use symlinks nukes at all? TRUE/FALSE
PRENUKEINCOM="TRUE"   # Send pre-nuke warning?
EARLYINCOM="120"      # Minutes before sending a pre-nuke warning. 
TIMEINCOM="200"       # Minumum age in minutes to nuke.
INCOMMULTIPLIER="2"   # Nuke multiplier
EMBARRESINCOM="TRUE"  # Send detailed nuke report.
SYMLINKNAMES="[incomplete]-"  # What does your symlinks contain.
CLEANSYMLINKS="TRUE"  # Remove "dead" symlinks? 
CLEANMESSAGE="FALSE"  # Clean .message file of incompletes?
INCOMHOURS="TRUE"     # Use hours in bot and log output?

JUMPON="CD1 CD2 CD3 CD4 CD5 CD6 CD7 Cd1 Cd2 Cd3 Cd4 Cd5 Cd6 Cd7" # See README


#---[ Banned words module ]---#
BANNEDWORDS="TRUE"   # Use banned words module at all? TRUE/FALSE.

BANDIRS="
/site/0DAYS/$today~.German*2:.French*2:.Solaris:.UNIX*4
/site/0DAYS/$yesterday~.German*2:.French*2:.Solaris
/site/SVCD~-FTF*5:-SMB*5
/site/DIVX~-FTF*5:-SMB*5
/site/VCD~-FTF*4:-SMB*4
"

ALLOWED="Allowed"    # What makes it ok?
BANEXCLUDE="-MyTH -PeKKA" # Special exclude for this module.
BANPRENUKE="TRUE"    # Send a pre-nuke warning?
EARLYBANPRENUKE="1"  # Minutes before I send pre-nuke warning?
TIMEBANNUKE="15"     # Minutes, before I nuke it?
BANMULTIPLIER="3"    # Default Multiplier to nuke for banned words.
EMBARRESBAN="TRUE"   # Send detailed nuke report.
BANHOURS="FALSE"     # Use hours in bot and log output?

#---[ Generics ]---#
DELETENUKES="TRUE"             # Delete nuked folders after...
TIMETODELEM="24"               # the are this many hours old.

USEREXCLUDE="UNKNOWN"          # Dont show in EMBARRES nuke output.
MATCHUSER="TRUE"               # Try to find username when sending nuke warn?
NOUSERFOUND="someone unknown"  # Cant find user to match? Use this.
SHWING="TRUE"                  # Shwing it, magistern.
BOTTRIGGER="AUTONUKE:"         # Trigger for your bot.


###########################################################################################
# Yadda Yadda, no changes below here, rip off balls etc etc.                              #
###########################################################################################

## Check date for the logfile.
DATENOW="$(date +%D" - "%T)"

## Nuked dir syntax. Dont want to nuke those again.
# Old one: NUKES="$( grep nukedir_style $GLCONF | egrep -iv '#' | cut -f2-2 | awk -F"%" -F"-" '{print $1}' )"
NUKES="$( grep nukedir_style $GLCONF | egrep -iv '#' | awk -F" " '{print $2}'  | awk -F"%" -F"-" '{print $1}' )"

if [ -e $LOG ]; then
  foundit=yes
else
  touch $LOG
  chmod 777 $LOG
fi

if [ "$SHWING" = "TRUE" ]; then
  echo "Read the instructions before running this!"
  exit 1
fi

if [ "$PRENUKEEMPTY" = "TRUE" -o "$PRENUKEINCOM" = "TRUE" -o "$PRENUKEHALFEMPTY" = "TRUE" -o "$BANNEDWORDS" = "TRUE" ]; then
  if [ -e "$GLLOG" ]; then
    foundit=yes
  else
    echo "You have early pre-nuke warnings enabled, but $GLLOG was not found."
    echo "Either fix GLLOG or set all pre-nuke warnings to FALSE."
    exit 1
  fi
fi

## How long is $GLROOT so we can cut it out when we need to nuke?
CUT="$( echo $GLROOT | wc -c )"

if [ "$CUT" -lt "2" ]; then
  echo "You havent set a GLROOT? Dooo sooo."
  exit 1
fi

if [ "$MATCHUSER" = "TRUE" ]; then
  if [ -e $GLLOG ]; then
    ok=yes
  else
    echo "You have MATCHUSER on TRUE, but I cant find the $GLLOG (GLLOG) file. Fix it."
    exit 1
  fi
fi

## Verify that nuked line dosnt contain [](){}. If it does, set it to NUKED. No biggie anyway.
## Grep line dosnt like to exclude stuff with those chars in em.
NUKEVER="$( echo $NUKES | grep -F '[' )"
if [ "$NUKEVER" != "" ]; then NUKES="NUKED"; fi; NUKEVAR=""
NUKEVER="$( echo $NUKES | grep -F ']' )"
if [ "$NUKEVER" != "" ]; then NUKES="NUKED"; fi; NUKEVAR=""
NUKEVER="$( echo $NUKES | grep -F '(' )"
if [ "$NUKEVER" != "" ]; then NUKES="NUKED"; fi; NUKEVAR=""
NUKEVER="$( echo $NUKES | grep -F ')' )"
if [ "$NUKEVER" != "" ]; then NUKES="NUKED"; fi; NUKEVAR=""
NUKEVER="$( echo $NUKES | grep -F '{' )"
if [ "$NUKEVER" != "" ]; then NUKES="NUKED"; fi; NUKEVAR=""
NUKEVER="$( echo $NUKES | grep -F '}' )"
if [ "$NUKEVER" != "" ]; then NUKES="NUKED"; fi; NUKEVAR=""

for dirs in $DIRS; do
  if [ -e $GLROOT$dirs ]; then
    ok=yes  
  else
    if [ "$1" = "test" ]; then
      echo ""
      echo "WARNING:"
      echo "I can not find $GLROOT$dirs - I'll just skip that one."
      echo "Check the DIRS= settings."
    fi
    if [ "$LOG" != "" ]; then
      echo "$DATENOW Error: Can not find $dirs specified in DIRS. Skipping it." >> $LOG
    fi       
  fi
done

if [ "$CLEANHOURS" != "" ]; then
  CLEANMINUTES="$( expr "$CLEANHOURS" \* "60" )"
fi

if [ "$TIMETODELEM" != "" ]; then
  TIMETODELEM="$( expr "$TIMETODELEM" \* "60" )"
else
  if [ "$DELETENUKES" = "TRUE" ]; then
    if [ "$1" = "test" ]; then
      echo "Error: You have DELETENUKES on TRUE, but no time specified in TIMETODELEM."
      echo "Setting DELETENUKES to FALSE."
      DELETENUKES="FALSE"
    else
      echo "$DATENOW Error: You have DELETENUKES on TRUE, but no time specified in TIMETODELEM." >> $LOG
    fi
  fi
fi

if [ "$1" = "test" ]; then
  echo "Welcome to Tur-AutoNuke version $VER"
fi

####################################################################################
## Totally empty folders check                                                     #
####################################################################################

if [ "$TOTALLYEMPTY" = "TRUE" ]; then
  
  ETIME=""
  NTIME=""
  if [ "$EMPTYHOURS" = "TRUE" ]; then
    EARLYEMPTYD="$( expr $EARLYEMPTY \/ 60 )"
    if [ "$EARLYEMPTYD" -gt "1" ]; then
      ETIME="hours"
    else
      ETIME="hour"
    fi
    TIMEEMPTYD="$( expr $TIMEEMPTY \/ 60 )" 
    if [ "$TIMEEMPTYD" -gt "1" ]; then
      NTIME="hours"
    else
      NTIME="hour"
    fi
    ETIME="$EARLYEMPTYD $ETIME"
    NTIME="$TIMEEMPTYD $NTIME"
  else
    EARLYEMPTYD="$EARLYEMPTY"
    if [ "$EARLYEMPTYD" -gt "1" ]; then
      ETIME="minutes"
    else
      ETIME="minute"
    fi
    TIMEEMPTYD="$TIMEEMPTY" 
    if [ "$TIMEEMPTYD" -gt "1" ]; then
      NTIME="minutes"
    else
      NTIME="minute"
    fi
    ETIME="$EARLYEMPTYD $ETIME"
    NTIME="$TIMEEMPTYD $NTIME"
  fi

  if [ "$1" = "test" ]; then
    echo ""
    echo "-[ Checking empty folders. Warn: $ETIME - Nuke: $NTIME ]-"
  fi

  for folders in $DIRS; do
    if [ -e "$GLROOT$folders" ]; then
      cd $GLROOT$folders
    
      if [ "$1" = "test" ]; then
        echo "--Entering $folders"
      fi

      for found in `find $GLROOT$folders -empty -type d -mmin +$TIMEEMPTY -maxdepth 1 -print | grep -vi "$NUKES" | grep -vx $GLROOT$folders | cut -b$CUT-`; do
        if [ "$1" = "test" ]; then
          echo "Folder: $folders  Other: $found  Empty more then $NTIME. Nuking it (test)."
        fi
        FOUNDEMPTYNUKE="$folders"
        if [ "$1" != "test" ]; then
          CORE="$($NUKEPROG -r $GLCONF -N $NUKEUSER -n $found $EMPTYMULTIPLIER -Auto- Empty for more than $NTIME.)"
          echo "$DATENOW Nuke: $found - Empty after $NTIME. $EMPTYMULTIPLIER Nuke." >> $LOG
          ## Nuke Detail
          if [ "$EMBARRESEMPTY" = "TRUE" ]; then
            CORECHECK="$( echo $CORE | cut -b-5 )"
            if [ "$CORECHECK" = "Empty" ]; then
              CORE="$( echo $CORE | cut -b90- )"
            else 
              CORE="$( echo $CORE | cut -b205- )"
            fi
            CORE="$( echo $CORE | tr -s '-' ' ' )"
            gotuser=""
            for each in $CORE; do
              if [ "$next" = "yes" ]; then
                if [ "$USEREXCLUDE" != "$each" ]; then
                  users="$users \002(\002$each"
                  uexcluded="no"
                  gotuser="true"
                else
                  uexcluded="yes"
                fi
              fi
              if [ "$each" = "Nukee:" ]; then
                next="yes" 
              else 
                next="no"
              fi
              if [ "$next2" = "yes" ]; then
                if [ "$uexcluded" = "no" ]; then
                  users="$users lost \037$each\037\002)\002"
                fi
              fi
              if [ "$each" = "Lost:" ]; then
                next2="yes" 
              else 
                next2="no"
              fi
            done
            if [ "$gotuser" = "true" ]; then
              sleep 1
              echo "$(date +'%a %b %d %T %Y') $BOTTRIGGER \002-(AutoNuke)- Loosers:\002 $users" >> $GLLOG
              sleep 2
            fi
            users=""
          fi
        fi
      done
      ## Early Pre-Nuke warning
      if [ "$PRENUKEEMPTY" = "TRUE" ]; then
        for found in `find $GLROOT$folders -empty -type d -mmin +$EARLYEMPTY -maxdepth 1 -print | grep -vi "$NUKES" | grep -vx $GLROOT$folders | cut -b$CUT-`; do
         if [ "$FOUNDEMPTYNUKE" != "$folders" ]; then
           REALEMPTYTMP="$( echo $found | tr -s '/' ' ' )"
           for o in $REALEMPTYTMP; do
             REALEMPTY="$o"
           done
           BANPROCESS="TRUE"
           if [ "$MATCHUSER" = "TRUE" ]; then
             ## Find owner of dir
             uname=""
             unames=""
             for unames in `cat $GLLOG | grep -w $folders/$REALEMPTY'"' | grep -w NEWDIR: | awk -F" " '{print $8}' | tr -d '"'`; do
               uname="$unames"
             done
             if [ "$uname" = "" ]; then
               uname=" created by $NOUSERFOUND"
             else
               uname=" created by $uname"
             fi
           fi
           ## Find out parent folder of the nuke.
           lastfolder="$( echo $folders | tr -s '/' ' ' )" 
           for lastfolders in $lastfolder; do
             lastfolder="$lastfolders"
           done
           if [ "$1" = "test" ]; then
             if [ -e "$TEMPDIR/prewarned.$REALEMPTY" ]; then
               echo "$lastfolder/$REALEMPTY$uname empty more then $ETIME. Already sent Pre-warning though (test)."
               echo "  -Remove $TEMPDIR/prewarned.$REALEMPTY to send again."
             else
               echo "$lastfolder/$REALEMPTY$uname empty more then $ETIME. Sending pre-nuke warning (test)."
               echo "Prewarning" > $TEMPDIR/prewarned.$REALEMPTY
             fi
           fi
           if [ "$1" != "test" ]; then
             if [ -e "$TEMPDIR/prewarned.$REALEMPTY" ]; then
               BANPROCESS="TRUE"
             else
               echo "$(date +'%a %b %d %T %Y') $BOTTRIGGER \002-(AutoNuke)- $lastfolder/$REALEMPTY\002$uname, is still empty after $ETIME. Will be nuked when its \002$NTIME\002 old." >> $GLLOG
               echo "$DATENOW Warn: $found$uname, Pre-nuke warning (empty) sent. More then $ETIME old." >> $LOG
               echo "Prewarning" > $TEMPDIR/prewarned.$REALEMPTY
             fi
           fi
         fi
         FOUNDEMPTYNUKE=""
         lastfolder=""
        done
      fi
    fi
  done
fi


####################################################################################
## Half empty module                                                               #
####################################################################################

if [ "$HALFEMPTY" = "TRUE" ]; then

  ETIME=""
  NTIME=""
  if [ "$HALFHOURS" = "TRUE" ]; then
    EARLYHALFEMPTYD="$( expr $EARLYHALFEMPTY \/ 60 )"
    if [ "$EARLYHALFEMPTYD" -gt "1" ]; then
      ETIME="hours"
    else
      ETIME="hour"
    fi
    TIMEHALFEMPTYD="$( expr $TIMEHALFEMPTY \/ 60 )" 
    if [ "$TIMEHALFEMPTYD" -gt "1" ]; then
      NTIME="hours"
    else
      NTIME="hour"
    fi
    ETIME="$EARLYHALFEMPTYD $ETIME"
    NTIME="$TIMEHALFEMPTYD $NTIME"
  else
    EARLYHALFEMPTYD="$EARLYHALFEMPTY"
    if [ "$EARLYHALFEMPTYD" -gt "1" ]; then
      ETIME="minutes"
    else
      ETIME="minute"
    fi
    TIMEHALFEMPTYD="$TIMEHALFEMPTY" 
    if [ "$TIMEHALFEMPTYD" -gt "1" ]; then
      NTIME="minutes"
    else
      NTIME="minute"
    fi
    ETIME="$EARLYHALFEMPTYD $ETIME"
    NTIME="$TIMEHALFEMPTYD $NTIME"
  fi

  if [ "$1" = "test" ]; then
    echo ""
    echo "-[ Checking half-empty folders. Warn: $ETIME - Nuke: $NTIME ]-"
  fi

  ## Make a | between excluded folders.
  EXCLUDESPECIAL="$( echo $EXCLUDES | tr -s ' ' '|' )"
  ## Add the nuked syntax to it too.
  EXCLUDESPECIAL="$EXCLUDESPECIAL|$NUKES"

  ## Clean out index file if enough time has passed, unless disabled.
  if [ "$CLEANMINUTES" != "" ]; then
    if [ -e $TEMPDIR/tur-autonuke.time ]; then
      if [ -e $TEMPDIR/tur-autonuke.index ]; then
        for found in `find $TEMPDIR/tur-autonuke.time -mmin +$CLEANMINUTES -maxdepth 0 -print`; do
          if [ "$1" = "test" ]; then
            echo "Index file more then $CLEANHOURS hours old. Making a new one."
          fi
          echo "$DATENOW CLEAN: $TEMPDIR/tur-autonuke.index more then $CLEANHOURS hours old. Cleaning it." >> $LOG
          mv -f $TEMPDIR/tur-autonuke.index $TEMPDIR/tur-autonuke.oldindex
          touch $TEMPDIR/tur-autonuke.time
        done
      fi
    else
      touch $TEMPDIR/tur-autonuke.time
    fi
  fi

  ## Lets rock the folders. See what we can find...
  for folders in $DIRS; do
    if [ -e $GLROOT$folders ]; then
      cd $GLROOT$folders

      if [ "$1" = "test" ]; then
        echo "--Entering $folders"
      fi
 
      for them in `ls | egrep -v '\[' | egrep -v '\(' | egrep -iv $EXCLUDESPECIAL`; do
        #echo "Checking $them"
         
        if [ -e $TEMPDIR/tur-autonuke.index ]; then
          INDEX="$( cat $TEMPDIR/tur-autonuke.index | grep -w $folders/$them )"
        else
          echo "$DATENOW INDEX: No index file found. Building a new one..." >> $LOG
          if [ "$1" = "test" ]; then
            echo "Since this seems to be the first time you run the half-empty module"
            echo "or the index file has just been cleaned, I will now build the" 
            echo "index file to speed it up next time its run."
            echo "I will also check for half-empty folders while I'm at it."
            echo "This can take a while..."
            echo ""
          fi
        fi
        if [ "$INDEX" = "" ]; then
          GOTTHROUGH="TRUE"
          for content in `ls -LR $them`; do
            if [ "$GOTFILE" != "TRUE" ]; then
              for excludes in $EMPTYEXCLUDE; do
                if [ "$GOTFILE" != "TRUE" ]; then
                  if [ "$ALREADYFOUND" != "TRUE" ]; then
                    VERIFY="$( echo $content | grep -i $excludes )"
                    #echo "$them - echoing $content and grepping $excludes"
                    if [ "$VERIFY" != "" ]; then
                      #echo "VERIFY: $VERIFY found from $them"
                      ALREADYFOUND="TRUE"
                      echo "$folders/$them" >> $TEMPDIR/tur-autonuke.index
                    fi
                    if [ "$VERIFY" != "" ]; then
                      GOTFILE="TRUE"
                    fi
                  fi
                fi
              done
            fi
          done
        fi
        if [ "$GOTFILE" != "TRUE" ]; then
          if [ "$GOTTHROUGH" = "TRUE" ]; then
            for found in `find $GLROOT$folders/$them -type d -mmin +$TIMEHALFEMPTY -maxdepth 0 -print | grep -vi "$NUKES" | grep -vx $them | cut -b$CUT-`; do
              if [ "$1" = "test" ]; then
                echo "$folders/$them seems empty and is older then $NTIME. Nuking! (test)"
              else
                CORE="$( $NUKEPROG -r $GLCONF -N $NUKEUSER -n $folders/$them $HALFEMPTYMULTIPLIER -Auto- Empty for more then $NTIME )"
                echo "$DATENOW Nuke: $folders/$them - Half-empty after $NTIME. $HALFEMPTYMULTIPLIER Nuke." >> $LOG
                ## Nuke Detail
                if [ "$EMBARRESHALF" = "TRUE" ]; then
                  CORECHECK="$( echo $CORE | cut -b-5 )"
                  if [ "$CORECHECK" = "Empty" ]; then
                    CORE="$( echo $CORE | cut -b90- )"
                  else 
                    CORE="$( echo $CORE | cut -b205- )"
                  fi
                  CORE="$( echo $CORE | tr -s '-' ' ' )"
                  gotuser=""
                  for each in $CORE; do
                    if [ "$next" = "yes" ]; then
                      if [ "$USEREXCLUDE" != "$each" ]; then
                        users="$users \002(\002$each"
                        uexcluded="no"
                        gotuser="true"
                      else
                        uexcluded="yes"
                      fi
                    fi
                    if [ "$each" = "Nukee:" ]; then
                      next="yes" 
                    else 
                      next="no"
                    fi
                    if [ "$next2" = "yes" ]; then
                      if [ "$uexcluded" = "no" ]; then
                        users="$users lost \037$each\037\002)\002"
                      fi
                    fi
                    if [ "$each" = "Lost:" ]; then
                      next2="yes" 
                    else 
                      next2="no"
                    fi
                  done
                  if [ "$gotuser" = "true" ]; then
                    sleep 1
                    echo "$(date +'%a %b %d %T %Y') $BOTTRIGGER \002-(AutoNuke)- Loosers:\002 $users" >> $GLLOG
                    sleep 2
                  fi
                  users=""
                fi
              fi
              HALFEMPTY="TRUE"
            done
            if [ "$HALFEMPTY" != "TRUE" ]; then
              for found in `find $GLROOT$folders/$them -type d -mmin +$EARLYHALFEMPTY -maxdepth 0 -print | grep -vi "$NUKES" | grep -vx $them | cut -b$CUT-`; do
                if [ "$MATCHUSER" = "TRUE" ]; then
                  ## Find owner of dir
                  uname=""
                  unames=""
                  for unames in `cat $GLLOG | grep -w $folders/$them'"' | grep -w NEWDIR: | awk -F" " '{print $8}' | tr -d '"'`; do
                    uname="$unames"
                  done
                  if [ "$uname" = "" ]; then
                    uname=" created by $NOUSERFOUND"
                  else
                    uname=" created by $uname"
                  fi
                fi
                ## Find out parent folder of the nuke.
                lastfolder="$( echo $folders | tr -s '/' ' ' )" 
                for lastfolders in $lastfolder; do
                  lastfolder="$lastfolders"
                done
                if [ -e "$TEMPDIR/prewarned.$them" ]; then
                  if [ "$1" = "test" ]; then
                    if [ "$REALEMPTY" != "$them" ]; then
                      echo "$folders/$them$uname seems empty after $ETIME. Pre nuke warning already sent (test)"
                    fi
                  fi
                else
                  if [ "$1" = "test" ]; then
                    if [ "$PRENUKEHALFEMPTY" = "TRUE" ]; then
                      if [ "$REALEMPTY" != "$them" ]; then
                        echo "$folders/$them$uname seems empty after $ETIME. Sending pre-nuke warning (test)"
                      fi
                    fi
                    echo "Tur-autonuke prewarning file" > $TEMPDIR/prewarned.$them
                  else
                    if [ "$PRENUKEHALFEMPTY" = "TRUE" ]; then
                      echo "$(date +'%a %b %d %T %Y') $BOTTRIGGER \002-(AutoNuke)- $lastfolder/$them\002$uname, Empty or incomplete after $ETIME. Will be nuked when its \002$NTIME\002 old." >> $GLLOG
                      echo "$DATENOW Warn: $folders/$them$uname, Half-empty after $ETIME. Pre-nuke warning sent." >> $LOG
                      echo "Tur-autonuke prewarning file" > $TEMPDIR/prewarned.$them
                    fi
                  fi
                fi
                lastfolder=""
              done
            fi
            HALFEMPTY=""
            BANPROCESS="TRUE"
          else
            CORE="YES"
            #echo "$them already checked"
          fi
        fi
        GOTTHROUGH=""
        GOTFILE="FALSE"
        HALFEMPTY=""
        ALREADYFOUND="FALSE"
        them=""
      done
    fi
    them=""
  done
fi


############################################################################
# Checking incompleted releases by symlink.                                #
############################################################################

if [ "$INCOMPLETE" = "TRUE" ]; then
  REALNAME=""

  ETIME=""
  NTIME=""
  if [ "$INCOMHOURS" = "TRUE" ]; then
    EARLYINCOMD="$( expr $EARLYINCOM \/ 60 )"
    if [ "$EARLYINCOMD" -gt "1" ]; then
      ETIME="hours"
    else
      ETIME="hour"
    fi
    TIMEINCOMD="$( expr $TIMEINCOM \/ 60 )" 
    if [ "$TIMEINCOMD" -gt "1" ]; then
      NTIME="hours"
    else
      NTIME="hour"
    fi
    ETIME="$EARLYINCOMD $ETIME"
    NTIME="$TIMEINCOMD $NTIME"
  else
    EARLYINCOMD="$EARLYINCOM"
    if [ "$EARLYINCOMD" -gt "1" ]; then
      ETIME="minutes"
    else
      ETIME="minute"
    fi
    TIMEINCOMD="$TIMEINCOM" 
    if [ "$TIMEINCOMD" -gt "1" ]; then
      NTIME="minutes"
    else
      NTIME="minute"
    fi
    ETIME="$EARLYINCOMD $ETIME"
    NTIME="$TIMEINCOMD $NTIME"
  fi

  if [ "$1" = "test" ]; then
    echo ""
    echo "-[ Checking incompletes. Warn: $ETIME - Nuke: $NTIME ]-"
  fi

  for folders in $DIRS; do
    if [ -e $GLROOT$folders ]; then
      cd $GLROOT$folders

      if [ "$1" = "test" ]; then
        echo "--Entering $folders"
      fi
      LIST="$( ls -m )"

      for dirs in $LIST; do
        for SYMLINKNAME in $SYMLINKNAMES; do
          VERIFY="$( echo $dirs | grep -F $SYMLINKNAME )"
          if [ "$VERIFY" != "" ]; then
            VERIFY="$( echo $VERIFY | tr -d ',' )"
            if [ "$1" = "test" ]; then
              echo "Found incomplete link: $VERIFY"
            fi
            CHECK="$( ls -l $GLROOT$folders | grep -F $VERIFY )"
            CHECK="$( echo $CHECK | awk -F ">" '{print $2}' | tr -s '/' ' ' )"
            for crap in $CHECK; do
              LAST="$REALNAME"
              REALNAME="$crap"
            done
            for jump in $JUMPON; do
              if [ "$REALNAME" = "$jump" ]; then
                REALNAME="$LAST"
              fi
            done

            if [ -e "$REALNAME" ]; then
              for folder in `find $REALNAME -type d -mmin +$TIMEINCOM -maxdepth 1 -print | grep -vi "$NUKES" | grep -vx $REALNAME | cut -b$CUT-`; do
                if [ "$REALNAME" != "$LAST" ]; then
                  EXCLUDE="NO"
                  for excludes in $EXCLUDES; do
                    VERIFY2="$( echo $REALNAME | grep -i $excludes )"
                    if [ "$VERIFY2" != "" ]; then
                      EXCLUDE="YES"
                    fi
                  done

                  if [ "$EXCLUDE" != "YES" ]; then
                    if [ "$1" = "test" ]; then
                      echo "$REALNAME is older then $NTIME. Nuking it (test)."
                    fi

                    if [ "$CLEANMESSAGE" = "TRUE" ]; then
                      if [ -e $GLROOT/$folders/.message ]; then
                        if [ "$1" = "test" ]; then
                          CHECKMESSAGE="$( cat $GLROOT/$folders/.message | grep -w $REALNAME )"
                          echo "Removing release from .message (test, line follows below:)"
                          echo "$CHECKMESSAGE"
                        else
                          cat $GLROOT/$folders/.message | grep -v "$REALNAME" > $TEMPDIR/message.tmp
                          mv -f $TEMPDIR/message.tmp $GLROOT/$folders/.message
                          #echo "Actually removed it from .message"
                        fi
                      else
                        if [ "$1" = "test" ]; then
                          echo "CLEANMESSAGE is TRUE, but no .message found in $GLROOT/$folders."
                        fi
                      fi
                    fi
                
                    if [ "$1" != "test" ]; then
                      CORE="$( $NUKEPROG -r $GLCONF -N $NUKEUSER -n $folders/$REALNAME $INCOMMULTIPLIER -Auto- Not completed for $NTIME. )"
                      echo "$DATENOW Nuke: $folders/$REALNAME - Incomplete after $NTIME. $INCOMMULTIPLIER Nuke." >> $LOG
                      JUSTNUKED="$REALNAME"
                      ## Nuke Detail
                      if [ "$EMBARRESINCOM" = "TRUE" ]; then
                        CORECHECK="$( echo $CORE | cut -b-5 )"
                        if [ "$CORECHECK" = "Empty" ]; then
                          CORE="$( echo $CORE | cut -b90- )"
                        else 
                          CORE="$( echo $CORE | cut -b205- )"
                        fi
                        CORE="$( echo $CORE | tr -s '-' ' ' )"
                        gotuser=""
                        for each in $CORE; do
                          if [ "$next" = "yes" ]; then
                            if [ "$USEREXCLUDE" != "$each" ]; then
                              users="$users \002(\002$each"
                              uexcluded="no"
                              gotuser="true"
                            else
                              uexcluded="yes"
                            fi
                          fi
                          if [ "$each" = "Nukee:" ]; then
                            next="yes" 
                          else 
                            next="no"
                          fi
                          if [ "$next2" = "yes" ]; then
                            if [ "$uexcluded" = "no" ]; then
                              users="$users lost \037$each\037\002)\002"
                            fi
                          fi
                          if [ "$each" = "Lost:" ]; then
                            next2="yes" 
                          else 
                            next2="no"
                          fi
                        done
                        if [ "$gotuser" = "true" ]; then
                          sleep 1
                          echo "$(date +'%a %b %d %T %Y') $BOTTRIGGER \002-(AutoNuke)- Loosers:\002 $users" >> $GLLOG
                          sleep 2
                        fi
                        users=""
                      fi
                    fi
                    LAST="$REALNAME"
                  else
                    if [ "$1" = "test" ]; then
                      if [ "$SAIDIT" != "$REALNAME" ]; then
                        #echo "$REALNAME is excluded"
                        SAIDIT="$REALNAME"
                      fi
                    fi
                  fi
                  if [ "$CLEANSYMLINKS" = "TRUE" ]; then
                    if [ "$CLEANMESSAGE" = "TRUE" ]; then
                      if [ -e $GLROOT/$folders/.message ]; then
                        if [ "$1" = "test" ]; then
                          CHECKMESSAGE="$( cat $GLROOT/$folders/.message | grep -w $REALNAME )"
                          echo "Removing release from .message (test, line follows below:)"
                          echo "$CHECKMESSAGE"
                        else
                          cat $GLROOT/$folders/.message | grep -v "$REALNAME" > $TEMPDIR/message.tmp
                          mv -f $TEMPDIR/message.tmp $GLROOT/$folders/.message
                          #echo "Actually removed it from .message"
                        fi
                      else
                        if [ "$1" = "test" ]; then
                          echo "CLEANMESSAGE is TRUE, but no .message found in $GLROOT/$folders."
                        fi
                      fi
                    fi
                    if [ "$1" != "test" ]; then
                      rm -rf $VERIFY
                      echo "$DATENOW Dele: Removing symlink $VERIFY" >> $LOG
                    fi
                    if [ "$1" = "test" ]; then
                      if [ "$SAIDIT2" != "$REALNAME" ]; then
                        echo "Removing symlink: $VERIFY (test)"
                        echo ""
                        SAIDIT2="$REALNAME"
                      fi
                    fi
                  fi
                fi
              done
              if [ "$PRENUKEINCOM" = "TRUE" ]; then
                if [ "$JUSTNUKED" != "$REALNAME" ]; then
                  LAST=""
                  for folder in `find $REALNAME -type d -mmin +$EARLYINCOM -maxdepth 1 -print | grep -vi "$NUKES" | grep -vx $REALNAME | cut -b$CUT-`; do
                    if [ "$REALNAME" != "$LAST" ]; then
                      if [ "$MATCHUSER" = "TRUE" ]; then
                        ## Find owner of dir
                        uname=""
                        unames=""
                        for unames in `cat $GLLOG | grep -w $folders/$REALNAME'"' | grep -w NEWDIR: | awk -F" " '{print $8}' | tr -d '"'`; do
                          uname="$unames"
                        done
                        if [ "$uname" = "" ]; then
                          uname=" created by $NOUSERFOUND"
                        else
                          uname=" created by $uname"
                        fi
                      fi
                      ## Find out parent folder of the nuke.
                      lastfolder="$( echo $folders | tr -s '/' ' ' )" 
                      for lastfolders in $lastfolder; do
                        lastfolder="$lastfolders"
                      done
                      EXCLUDE="NO"
                      for excludes in $EXCLUDES; do
                        VERIFY2="$( echo $REALNAME | grep -i $excludes )"
                        if [ "$VERIFY2" != "" ]; then
                          EXCLUDE="YES"
                        fi
                      done

                      if [ "$EXCLUDE" != "YES" ]; then
                        if [ "$1" = "test" ]; then
                          if [ -e "$TEMPDIR/prewarned.$REALNAME" ]; then
                            BANPROCESS="TRUE"
                            if [ "$SAIDIT4" != "$REALNAME" ]; then
                              echo "$REALNAME$uname is older then $ETIME. Pre warning already sent though. (test)"
                              echo "  -Remove $TEMPDIR/prewarned.$REALNAME to send again."
                              SAIDIT4="$REALNAME"
                            fi
                          else
                            PREWARNING="TRUE"
                            if [ "$SAIDIT3" != "$REALNAME" ]; then
                              echo "$REALNAME$uname is older then $ETIME. Pre-Nuke warning. (test)."
                              echo "$REALNAME" > $TEMPDIR/prewarned.$REALNAME
                              SAIDIT3="$REALNAME"
                              SAIDIT4="$REALNAME"
                            fi
                          fi
                        else
                          if [ "$GLLOG" != "" ]; then
                            if [ -e "$TEMPDIR/prewarned.$REALNAME" ]; then
                              BANPROCESS="TRUE"
                            else
                              BANPROCESS="TRUE"
                              if [ "$SAIDIT3" != "$REALNAME" ]; then
                                echo "$(date +'%a %b %d %T %Y') $BOTTRIGGER \002-(AutoNuke)- $lastfolder/$REALNAME\002$uname, has not been completed within $ETIME. Will be nuked when its \002$NTIME\002 old." >> $GLLOG
                                echo "$REALNAME" > $TEMPDIR/prewarned.$REALNAME
                                if [ "$SAIDIT4" != "$REALNAME" ]; then
                                  echo "$DATENOW Warn: $lastfolder/$REALNAME$uname is older then $ETIME. Sending pre-nuke warning" >> $LOG
                                  SAIDIT3="$REALNAME"
                                  SAIDIT4="$REALNAME"
                                fi
                              fi
                            fi
                          fi
                        fi
                      fi
                    fi
                    lastfolder=""
                  done
                fi
              fi
            else
              if [ "$1" = "test" ]; then
                echo "$REALNAME does NOT exist anymore"
              fi
              if [ "$CLEANSYMLINKS" = "TRUE" ]; then
                if [ "$1" != "test" ]; then
                  rm -rf $VERIFY
                  echo "$DATENOW Dele: Removing symlink $VERIFY" >> $LOG
                fi
                if [ "$1" = "test" ]; then
                  echo "Removing symlink to $VERIFY (test)"
                fi
              fi
            fi
          fi
          SAIDIT3=""
          SAIDIT4=""
          JUSTNUKED=""
          REALNAME=""
        done
      done
    fi
  done
fi


####################################################################################
## Banned words module                                                             #
####################################################################################

if [ "$BANNEDWORDS" = "TRUE" ]; then
  ## Make a | between excluded folders.
  EXCLUDESPECIAL="$( echo $EXCLUDES | tr -s ' ' '|' )"
  if [ "$BANEXCLUDE" != "" ]; then
    BANEXCLUDE="$( echo $BANEXCLUDE | tr -s ' ' '|' )"
    EXCLUDESPECIAL="$EXCLUDESPECIAL|$NUKES|$BANEXCLUDE"
  else
    EXCLUDESPECIAL="$EXCLUDESPECIAL|$NUKES"
  fi

  ETIME=""
  NTIME=""
  if [ "$BANHOURS" = "TRUE" ]; then
    EARLYBANPRENUKED="$( expr $EARLYBANPRENUKE \/ 60 )"
    if [ "$EARLYBANPRENUKED" -gt "1" ]; then
      ETIME="hours"
    else
      ETIME="hour"
    fi
    TIMEBANNUKED="$( expr $TIMEBANNUKE \/ 60 )" 
    if [ "$TIMEBANNUKED" -gt "1" ]; then
      NTIME="hours"
    else
      NTIME="hour"
    fi
    ETIME="$EARLYBANPRENUKED $ETIME"
    NTIME="$TIMEBANNUKED $NTIME"
  else
    EARLYBANPRENUKED="$EARLYBANPRENUKE"
    if [ "$EARLYBANPRENUKE" -gt "1" ]; then
      ETIME="minutes"
    else
      ETIME="minute"
    fi
    TIMEBANNUKED="$TIMEBANNUKE" 
    if [ "$TIMEBANNUKE" -gt "1" ]; then
      NTIME="minutes"
    else
      NTIME="minute"
    fi
    ETIME="$EARLYBANPRENUKE $ETIME"
    NTIME="$TIMEBANNUKE $NTIME"
  fi

  if [ "$1" = "test" ]; then
    echo ""
    echo "-[ Checking banned-words folders. Warn: $ETIME - Nuke: $NTIME ]-"
  fi

  for stuff in $BANDIRS; do
    folders="$( echo $stuff | awk -F"~" '{print $1}' )"
    BANWORD="$( echo $stuff | awk -F"~" '{print $2}' )"
    BANWORD="$( echo $BANWORD | tr -s ':' ' ' )"

    if [ "$1" = "test" ]; then
      echo "--Entering $folders. Banned words are $BANWORD"
    fi

    if [ -e $GLROOT$folders ]; then
      cd $GLROOT$folders

      for them in `ls | egrep -v '\[' | egrep -v '\(' | egrep -iv $EXCLUDESPECIAL`; do 
        #echo "Checking $them"
        for banword in $BANWORD; do
          MULTIPL="" 
          MULTIPL="$( echo $banword | awk -F"*" '{print $2}' )"
          banword="$( echo $banword | awk -F"*" '{print $1}' )"
          if [ "$MULTIPL" = "" ]; then
            MULTIPLIER="$BANMULTIPLIER"
          else
            MULTIPLIER="$MULTIPL"
          fi
          #echo "Multipler for $banword is $MULTIPLIER"
   
          VERIFY="$( echo $them | grep -F -i -- $banword )"
          #echo "Checking if $banword is in $them"
          if [ "$VERIFY" != "" ]; then
            #echo "$them contains a banned word!"
            for found in `find $GLROOT$folders/$them -type d -mmin +$TIMEBANNUKE -maxdepth 0 -print | grep -vi "$NUKES" | grep -vx $them | cut -b$CUT-`; do
              ALLOW="$( find $GLROOT$folders/$them -type d -maxdepth 1 -print | grep -i $ALLOWED )"
              if [ "$ALLOW" = "" ]; then
                BANPROCESS="TRUE"
                if [ "$1" = "test" ]; then
                  echo "$them ($banword) is older then $NTIME. NUKE! (test)"
                  BANLAST="$them"
                else
                  CORE="$( $NUKEPROG -r $GLCONF -N $NUKEUSER -n $folders/$them $MULTIPLIER -Auto- $banword not allowed )"
                  BANLAST="$them"
                  echo "$DATENOW Nuke: $folders/$them - Contains $banword after $NTIME. $MULTIPLIER Nuke." >> $LOG

                  ## Nuke Detail
                  if [ "$EMBARRESBAN" = "TRUE" ]; then
                    CORECHECK="$( echo $CORE | cut -b-5 )"
                    if [ "$CORECHECK" = "Empty" ]; then
                      CORE="$( echo $CORE | cut -b90- )"
                    else 
                      CORE="$( echo $CORE | cut -b205- )"
                    fi
                    CORE="$( echo $CORE | tr -s '-' ' ' )"
                    gotuser=""
                    for each in $CORE; do
                      if [ "$next" = "yes" ]; then
                        if [ "$USEREXCLUDE" != "$each" ]; then
                          users="$users \002(\002$each"
                          uexcluded="no"
                          gotuser="true"
                        else
                          uexcluded="yes"
                        fi
                      fi
                      if [ "$each" = "Nukee:" ]; then
                        next="yes" 
                      else 
                        next="no"
                      fi
                      if [ "$next2" = "yes" ]; then
                        if [ "$uexcluded" = "no" ]; then
                          users="$users lost \037$each\037\002)\002"
                        fi
                      fi
                      if [ "$each" = "Lost:" ]; then
                        next2="yes" 
                      else 
                        next2="no"
                      fi
                    done
                    if [ "$gotuser" = "true" ]; then
                      sleep 1
                      echo "$(date +'%a %b %d %T %Y') $BOTTRIGGER \002-(AutoNuke)- Loosers:\002 $users" >> $GLLOG
                      sleep 2
                    fi
                    users=""
                  fi
                fi
              else
                if [ "$1" = "test" ]; then
                  echo "$them ($banword) is older then $NTIME, but it has been allowed."
                fi
                BANLAST="$them"
              fi
            done
            if [ "$BANLAST" != "$them" ]; then
              for found in `find $GLROOT$folders/$them -type d -mmin +$EARLYBANPRENUKE -maxdepth 0 -print | grep -vi "$NUKES" | grep -vx $them | cut -b$CUT-`; do
                if [ "$MATCHUSER" = "TRUE" ]; then
                  ## Find owner of dir
                  uname=""
                  unames=""
                  for unames in `cat $GLLOG | grep -w $folders/$them'"' | grep -w NEWDIR: | awk -F" " '{print $8}' | tr -d '"'`; do
                    uname="$unames"
                  done
                  if [ "$uname" = "" ]; then
                    uname=" created by $NOUSERFOUND"
                  else
                    uname=" created by $uname"
                  fi
                fi
                ## Find out parent folder of the nuke.
                lastfolder="$( echo $folders | tr -s '/' ' ' )" 
                for lastfolders in $lastfolder; do
                  lastfolder="$lastfolders"
                done
                ALLOW="$( find $GLROOT$folders/$them -type d -maxdepth 1 -print | grep -i $ALLOWED )"
                if [ "$ALLOW" = "" ]; then
                  BANPROCESS="TRUE"
                  if [ "$1" = "test" ]; then
                    if [ -e $TEMPDIR/prewarned.$them ]; then
                      echo "$lastfolder/$them$uname ($banword) is older then $ETIME. Warning already sent. (test)"
                    else
                      echo "$them$uname ($banword) is older then $ETIME. Prenuke-warning (test)"
                      echo "Tur-autonuke prewarning file" > $TEMPDIR/prewarned.$them 
                    fi
                  else
                    if [ -e $TEMPDIR/prewarned.$them ]; then
                      CORE="yes"
                    else
                      if [ "$BANPRENUKE" = "TRUE" ]; then
                        if [ "$EARLYBANPRENUKE" = "1" ]; then
                          minutes="minute"
                        else
                          minutes="minutes"
                        fi
                        echo "$(date +'%a %b %d %T %Y') $BOTTRIGGER \002-(AutoNuke)- $lastfolder/$them\002$uname, $banword not allowed. Will be nuked when its \002$NTIME\002 old." >> $GLLOG
                        echo "Tur-autonuke prewarning file" > $TEMPDIR/prewarned.$them 
                        echo "$DATENOW Warn: $folders/$them$uname, Contains $banword after its $ETIME old. Pre-nuke warning sent." >> $LOG
                      fi
                    fi
                  fi
                else
                  if [ "$1" = "test" ]; then
                    echo "Would be pre warning time for $GLROOT$folders/$them, but its been allowed."
                  fi
                fi
              done
            fi
            VERIFY=""
          fi
        done
      done
    else
      if [ "$1" = "test" ]; then
        echo "I can not find $GLROOT$folders from the BANDIRS setting $stuff. Skipping it."
      fi
      if [ "$LOG" != "" ]; then
        echo "$folders from the bandir setting $stuff can not be found. Skipping it." >> $LOG
      fi
    fi
  done
fi

###############################################################################################
# Delete nuked folders                                                                        #
###############################################################################################

if [ "$DELETENUKES" = "TRUE" ]; then
  LIST=""
  EXCLUDESPECIAL=""
  dirs=""
  folders=""
  VERIFY=""
  ## Make a | between excluded folders.
  EXCLUDESPECIAL="$( echo $EXCLUDES | tr -s ' ' '|' )"

  if [ "$1" = "test" ]; then
    echo ""
    echo "-[ Checking for nuked folders to clean ]-"
  fi

  for folders in $DIRS; do
    if [ -e $GLROOT$folders ]; then
      cd $GLROOT$folders

      if [ "$1" = "test" ]; then
        echo "--Entering $folders"
      fi

      LIST="$( ls -m )"

      for dirs in $LIST; do
        VERIFY="$( echo $dirs | grep -F $NUKES )"
        if [ "$VERIFY" != "" ]; then
          VERIFY="$( echo $VERIFY | tr -d ',' )"
          if [ "$1" = "test" ]; then
            echo " Found nuked folder: $VERIFY"
          fi
          for found in `find $GLROOT$folders/$VERIFY -type d -mmin +$TIMETODELEM -maxdepth 0 -print | grep "$NUKES" | grep -vx $them | cut -b$CUT-`; do
            MB="$( du -s -m $GLROOT$folders/$VERIFY | awk -F" " '{print $1}' )"
            if [ "$1" = "test" ]; then
              echo " $VERIFY ($MB mb) is older then $TIMETODELEM minutes. Deleting it."
            else
              echo "$DATENOW Dele: Deleting nuked folder: $folders/$VERIFY ($MB mb) because its $TIMETODELEM minutes old." >> $LOG
              rm -rf $GLROOT$folders/$VERIFY
            fi
          done
        fi
      done
    fi
  done
fi

###########################################################################################
# End. Clean up prewarned files if theres been no warnings this time.                     #
###########################################################################################

if [ "$BANPROCESS" != "TRUE" ]; then
  rm -f $TEMPDIR/prewarned.*
fi

exit 0
